; EEPROM (  256 ).
;     Temp    ,   -  .
;      .
;  - 27  ( ,      EEPROM ).

EEPROM_Read:
        ;push   Tmp
        ;in     Tmp, SREG       ;    .
        ;push   Tmp
        ;cli                    ;      .

        sbic    EECR, EEWE      ; 
        rjmp    PC-1            ; .

        out     EEARL, Temp     ;     EEPROM.
        clr     Temp            ;   256  EEPROM.
        out     EEARH, Temp

        sbi     EECR, EERE      ; .
        in      Temp, EEDR      ;    Temp.

        ;pop    Tmp             ; 
        ;out    SREG, Tmp       ; .
        ;pop    Tmp
        ret

;*************************************************************************************************************************
;  EEPROM    Tmp        EEPROM,      Temp.
;   256  EEPROM.
;      .
; ,       eeprom ,  .
;  - 62 .

EepromWriteIfDifferent:
        ;push   R2
        ;in     R2, SREG        ;    .
        ;push   R2
        ;cli                     ;      .

        sbic    EECR, EEWE      ;    eeprom,
        rjmp    Exit_EepromWriteIfDifferent;  .
        ;in     R2, SPMCR       ;  
        ;sbrc   R2, SPMEN       ;  ,
        ;rjmp   Exit_EepromWriteIfDifferent;  .

        mov     R2, Temp        ;    eeprom.
        rcall   EEPROM_Read
        cp      Temp, Tmp       ;    .
        breq    Exit_EepromWriteIfDifferent;  ,   .

        mov     Temp, R2        ;   eeprom.
        out     EEARL, Temp     ;     EEPROM.
        clr     Temp            ;   256  EEPROM.
        out     EEARH, Temp
        out     EEDR, Tmp       ;     EEDR.

        sbi     EECR, EEMWE     ; 
        sbi     EECR, EEWE      ; EEPROM.

Exit_EepromWriteIfDifferent:
        ;pop    R2
        ;out    SREG, R2
        ;pop    R2
        ret

;*************************************************************************************************************************
;8-    .
;      Temp    1  255,       sram   mSeed.
;    (2^8 - 1) = 255.
; 8-       7, 5, 4  3 ,        (XOR,  -  eor).
;    seed - ,    .
; ,   ,         mSeed.  seed=0,   113.
;   ,      ,    ..     .
;     ,   SREG  Tmp   (   Tmp    SREG).
; :  ,   sram.
;   22  (   ret).
;  38    .

RandomNumber8bit:
        lds     Temp, mSeed             ; seed  sram.
        cpi     Temp, 0                 ; seed = 0,
        brne    PC+2
        ldi     Temp, 113               ;   113.

        mov     Tmp, Temp               ;  seed.
        lsl     Tmp                     ;   5-  seed
        lsl     Tmp                     ; 7-.
        eor     Temp, Tmp               ; XOR  7-  5- .
        lsl     Tmp                     ;   4-  seed  7-.
        eor     Temp, Tmp               ; XOR    XOR  4-  seed.
        lsl     Tmp                     ;   3-  seed  7-.
        eor     Temp, Tmp               ; XOR    XOR  3-  seed.
        rol     Temp                    ;     .
        lds     Temp, mSeed             ;   seed,
        rol     Temp                    ;        .

        sts     mSeed, Temp             ;       seed.
        ret

;*************************************************************************************************************************
; .
; ,    ,  : 4 * N + 46 = X, 
  ;N - ,      cDelay_N,
  ;X -  ,    .
; N = (X - 46) / 4.
;   ,   ( N=0)  46 .
;  N = 4 294 967 295.
  ;    1 (1  = 1)    17180  ( 286 ,   5 ).
;    ,     call (4 )  rcall (3 ).
;  N      4 .
;  N=65536,   .
  ;,    1.  (N=249989),    1.+12 .
  ;  4.  (N=999989),    4.+60 .
;   ,     ,    ,
 ;    4*Z.         Z.
  ;,  N>65535  Z    65536,
   ;,         4*65536=262144 .
;      .

WideRangeDelay:

.equ    cDelay_N = 499989       ;124997 - 0,5., 249994 - 1., 499989 - 2., 999989 - 4.

        ;push   Temp
        ;in     Temp, SREG
        ;push   Temp  
        ;cli
        ;push    R30
        ;push    R31
        ;push    R28
        push    R29

        ldi     R30, LOW  (cDelay_N)
        ldi     R31, HIGH (cDelay_N)
        ldi     R28, BYTE3(cDelay_N)
        ldi     R29, BYTE4(cDelay_N)

        adiw    R30, 1          ;   Z       Z=0.
        adiw    R28, 1          ;   Y       Y=0.

        sbiw    R30, 1
        brne    PC-1

        wdr

        sbiw    R28, 1
        brne    PC-4

        pop     R29
        ;pop     R28
        ;pop     R31
        ;pop     R30
        ;pop    Temp            ; 
        ;out    SREG, Temp      ; .
        ;pop    Temp
        ret

;  :
 ;6  push   6*2=12 
 ;1  in   1 
 ;1  cli   1 
 ;4  ldi   4*1=4 
 ;2  adiw   2*2=4 
 ;2  sbiw   2*2=4 
 ;2  brne   2*1=2  (    )
 ;1  wdr   1 
 ;6  pop   6*2=12 
 ;1  out   1 
 ;1  ret   4 
 ; 46 
